
void radix_sort_step(
    unsigned int A[],
    unsigned int B[],
    size_t size,
    size_t byte_index)
{
    size_t offs[257] = { 0 };
    size_t *count = &offs[1];
    size_t i;
    const unsigned char *pbyte = (const unsigned char *)A + byte_index;

    /* count occurences of each byte in the data */
    for (i = 0; i < size; ++i) ++count[pbyte[i*sizeof(A[0])]];

    /* sum occurences to get offsets */
    for (i = 1; i < 256; ++i) count[i] += count[i - 1];

    /* place elements in order */
    for (i = 0; i < size; ++i) B[offs[pbyte[i*sizeof(A[0])]]++] = A[i];
}

void radix_sort(
    unsigned int A[],
    unsigned int B[],
    size_t size)
{
    radix_sort_step(A, B, size, 0);
    radix_sort_step(B, A, size, 1);
    radix_sort_step(A, B, size, 2);
    radix_sort_step(B, A, size, 3);
}
